import sys
import select
import io

display = None

def keyReturnNonBlock():
    i,o,e = select.select([sys.stdin],[],[], 0.0001)
    for s in i:
        if s == sys.stdin:
            input = sys.stdin.readline().strip()
            return input
    return None

def display_set_mode( width, height):
    tmp = Screen()
    tmp.set_mode(width,height)
    return( tmp )

def draw_rect( screen, color, left, top, width, height ):
    #print("draw_rect", screen.width, screen.height, len(screen.screen), len(screen.screen[0]), color, left, top, width, height)
    for myrow in range(top,top+height):
        for mycol in range(left,left+width):
            #print(" draw_rect", myrow,mycol)
            screen.screen[mycol][myrow] = color

def display_update( screen ):
    screen.draw()
    
class Screen:
    def __init__(self):
        self.screen = None
        self.text = "None"
        
    def set_mode( self, width, height):
        self.width = width
        self.height = height
        self.screen = [ [" " for ii in range(height+1)] for jj in range(width+1)]

    def setDrawFunction( self, df ):
        self.drawfunction = df
        
    def fill( self, tofill ):
        for ii in range(self.width):
            for jj in range(self.height):
                self.screen[ii][jj] = tofill

    def settext( self, mytext ):
        self.text = mytext
            
    def draw( self ):
        myscreen = io.StringIO()
        myscreen.write("GAME:")
        if self.text == "None":
            myscreen.write(">>>>\n")
        else:
            myscreen.write(self.text+"\n")
        for ii in range(self.width+2):
            myscreen.write("-")
        myscreen.write("\n")
        for jj in range(self.height):
            myscreen.write("|")
            for ii in range(self.width):
                myscreen.write(self.screen[ii][jj][0])
            myscreen.write("|")
            myscreen.write("\n")
        for ii in range(self.width+2):
            myscreen.write("-")
        myscreen.write("\n")

        self.drawfunction( myscreen.getvalue() )

    def sendCmd( self, cmd ):
        print("sendCmd", cmd)
        self.drawfunction( cmd )
